<!DOCTYPE html>
<html lang="es">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <script>
        var datosProgramas;
        var filaAnterior = -1;
        var idAnterior = -1;
        window.onload = function () {
            var xhr = new XMLHttpRequest();
            xhr.onreadystatechange = function () {
                if (xhr.readyState == 4 && xhr.status == 200) {
                    var datos = JSON.parse(xhr.responseText);
                    if(datos.estado == '200'){
                        for(var i = 0; i < datos.data.length; i++){
                            var imagen = document.createElement('img');
                            imagen.src = 'logos/' + datos.data[i].url;
                            imagen.alt = datos.data[i].nombre;
                            imagen.id = datos.data[i].id;
                            imagen.addEventListener('click', muestraDatos);
                            document.getElementById('imagenes').appendChild(imagen);
                        }
                    }
                    else{
                        document.getElementsByTagName('body')[0].innerHTML = '<h1>Error en la carga de la BBDD</h1>';
                    }
                }
            }
            xhr.open("GET", "canales.php", true);
            xhr.send();
        }

        function muestraDatos(){
            var nombreCadena = this.alt;
            document.getElementById('datos').innerHTML = '<h3>' + nombreCadena + '</h3>';
            var xhr2 = new XMLHttpRequest();
            xhr2.onreadystatechange = function () {
                if (xhr2.readyState == 4 && xhr2.status == 200) {
                    if(xhr2.responseText == 'error'){
                        alert('No existe programación de TV para ' + nombreCadena);
                    }
                    else{
                        datosProgramas = JSON.parse(xhr2.responseText);
                        console.log(datosProgramas);
                        ordenaProgramacon(datosProgramas);
                        document.getElementById('tabla').innerHTML = "<tr><th>Hora</th><th>Programa</th></tr>"
                        for(var i = 0; i < datosProgramas.length; i++){
                            document.getElementById('tabla').innerHTML += "<tr><td>" + datosProgramas[i].hora + "</td><td onclick='muestraDescripcion(" + i + ", this)'>" + datosProgramas[i].nombre + "</td></tr>";
                        }   
                    }     
                }
            }
            xhr2.open("POST", "programas.php", true);
            xhr2.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
            xhr2.send('id=' + this.id + '&fecha=2018-03-07');
        }

        function muestraDescripcion(id, fila){
            if(fila.style.color != 'red'){
                if(datosProgramas[id].descripcion != null){
                    if(filaAnterior != -1){
                        filaAnterior.innerHTML = datosProgramas[idAnterior].nombre;
                        filaAnterior.style.color = 'black';
                    }
                    fila.innerHTML += '<br>' + datosProgramas[id].descripcion;
                    fila.style.color = 'red';
                    
                    filaAnterior = fila;
                    idAnterior = id; 
                }
            }
        }

        function ordenaProgramacon(datos){  
               
            datos.sort(function(a,b){
                var horario1 = a.hora.split(":")
                var horario2 = b.hora.split(":")
                if(Number(horario1[0]) < Number(horario2[0])){
                    return -1;
                }
                else if(Number(horario1[0]) == Number(horario2[0]) && Number(horario1[1]) < Number(horario2[1])){
                    return -1;
                }
                else if(Number(horario1[0]) == Number(horario2[0]) && Number(horario1[1]) == Number(horario2[1])){
                    return 0;
                }
                else{
                    return 1;
                }
            })
        }
    </script>

    <style>
    table, td, th {
        border: 1px solid black;
    }
    </style>
    <title>Programación de TV</title>
</head>

<body>
    <h1>Programación de TV del Miércoles 7 de Marzo de 2018</h1>
    <p>Pulsa sobre el canal</p>
    <div id="imagenes"></div>
    <div id="datos"></div>
    <table id="tabla"></table>
</body>

</html>